class Code
{
  int CodeWord;
  int BitLength;

  Code ()
  {
    BitLength = 0;
    CodeWord = 0;
  }

  Code (int CodeWord, int BitLength)
  {
    this.CodeWord = CodeWord;
    this.BitLength = BitLength;
  }

  int GetCodeWord ()
  { return CodeWord; }

  int GetBitLength ()
  { return BitLength; }

  void Encode (Bitstream BS)
    throws java.io.IOException
  {
    for (int i = BitLength - 1; i >= 0; i --)
        BS.WriteBit ((CodeWord & (1 << i)) != 0);
  }

  void ReadBit (Bitstream BS)
    throws java.io.EOFException, java.io.IOException
  {
    CodeWord <<= 1;
    if (BS.ReadBit ())
       CodeWord |= 1;
    BitLength ++;
  }

  boolean Equals (Code other)
  {
    return    other.GetCodeWord () == CodeWord
           && other.GetBitLength () == BitLength;
  }

  void Print ()
  {
    for (int i = BitLength - 1; i >= 0; i --)
        if   ((CodeWord & (1 << i)) != 0)
             System.out.print ('1');
        else System.out.print ('0');
  }

  public static void main (String[] args)
    throws java.io.FileNotFoundException, java.io.IOException
  {
    Bitstream BS = new Bitstream ("humppa");
    Code a = new Code (3, 2);
    Code b = new Code (5, 3);
    a.Encode (BS);
    b.Encode (BS);
    BS.Reset ();
    Code c = new Code ();
    c.ReadBit (BS);
    c.ReadBit (BS);
    c.Print ();
    System.out.println ();
    c = new Code ();
    c.ReadBit (BS);
    c.ReadBit (BS);
    c.ReadBit (BS);
    c.Print ();
    System.out.println ();
  }
}

