
/**
 * Created by IntelliJ IDEA.
 * User: thomas
 * Date: 11.06.2003
 * Time: 11:29:34
 * To change this template use Options | File Templates.
 */
public class ComplexWaveletTransformationWith2DVectorQuantisation {
    Signal1D realSig, imagSig;
    Signal1D[] complexSig = new Signal1D[2];
    int depth = 0;
    int bpv = 2;

    String fileName;
    Quantized1D qq;
    int numberOfVektors;

    ComplexWaveletTransformationWith2DVectorQuantisation(int depth, String fileName) {
        this.depth = depth;
        this.fileName = fileName;
    }

    public void setSignal(Signal1D sig) {
        this.realSig = sig;
    }

    public void encode(Signal1D sig) {
        try {
            this.realSig = sig;
            Bitstream B = new Bitstream(this.fileName);
            imagSig = realSig.ComplexWaveletTransform(depth);
            complexSig[0] = realSig;
            complexSig[1] = imagSig;

            VectorQuantizer VQ = new VectorQuantizer(2, 4);
            VQ.LBG(complexSig);

            Quantized1D Q = VQ.Quantize(this.complexSig);

            B.WriteInt(Q.Length());
            // codiere CodeBookVektoren und schicke sie auf B
            VQ.EncodeVectors(B);
            HuffmanCoder C = new HuffmanCoder(B);
            for (int x = 0; x < Q.Length(); x++) {
                C.Encode(Q.Get(x), 0);
            }

            C.Close();

            B.Close();
            VQ.Print();

        } catch (Exception e) {
            System.out.println(e);
        }
    }


    public Signal1D decode() {
        // dequantize des signals
        try {
            Bitstream B = new Bitstream(fileName);
            int numberOfSymbols = B.ReadInt();
            VectorQuantizer VQ = new VectorQuantizer(B.ReadInt(), B.ReadInt());
            VQ.DecodeVectors(B);
            double[] myVektor = new double[2];
            Quantized1D Q = new Quantized1D(numberOfSymbols);
            HuffmanCoder C = new HuffmanCoder(B);
            VQ.Dequantize (Q, complexSig);
            C.Close();
            complexSig[0].ComplexWaveletReconstruction(complexSig[1], depth);
            B.Close();

        } catch (Exception e) {
            System.out.println(e);
        }
        return (complexSig[1]);
    }


    public void setBpv(int bpv) {
        this.bpv = bpv;
    }

    public static void main(String[] args) {

        Signal1D realSig = new Signal1D(50);
        for (int i = 0; i < 50; i++)
            realSig.Set(i, 12 * i);
        ComplexWaveletTransformationWith2DVectorQuantisation myCWTW2DVQ
                = new ComplexWaveletTransformationWith2DVectorQuantisation
                        (new Integer(args[0]).intValue(), args[1]);
        myCWTW2DVQ.setBpv(8);

        realSig.Print();
        myCWTW2DVQ.encode(realSig);
        myCWTW2DVQ.decode().Print();
    }

}
