class Double2DSubArray extends Double2DArray
{
  private Double2DArray Array;

  private Position Origin;
  private Position Dim;

  Double2DSubArray (Double2DArray Array, Position Origin, Position Dim)
  {
    this.Array = Array;
    this.Origin = Origin;
    this.Dim = Dim;
  }

  public double Get (Position p)
  {
    return Array.Get (Origin.Plus (p));
  }

  public void Set (Position p, double v)
  {
    Array.Set (Origin.Plus (p), v);
  }

  public Position Dimension ()
  {
    return Dim;
  }

  public Position GetOrigin ()
  {
    return Origin;
  }

  public Double2DSubArray Quadrant (int Index)
  {
    return new Double2DSubArray
        ( Array
        , Origin.Plus
          ( new Position ( (Index & 1) == 0 ? 0 : Dim.X () / 2
                         , (Index & 2) == 0 ? 0 : Dim.Y () / 2
                         )
          )
        , new Position (Dim.X () / 2, Dim.Y () / 2)
        );
     
  }

  public static void main (String [] args)
  {
    Signal2D S = new Signal2D (new Position (3, 3));
    S.Set (new Position (0, 0), 1.1);
    S.Set (new Position (1, 0), 1.2);
    S.Set (new Position (2, 0), 1.3);
    S.Set (new Position (0, 1), 2.1);
    S.Set (new Position (1, 1), 2.2);
    S.Set (new Position (2, 1), 2.3);
    S.Set (new Position (0, 2), 3.1);
    S.Set (new Position (1, 2), 3.2);
    S.Set (new Position (2, 2), 3.3);
    S.Print ();
    Double2DSubArray DSA = new Double2DSubArray (S, new Position (0, 1), new Position (2, 2));
    DSA.Print ();
  }
}
