class Int2DSubArray extends Int2DArray
{
  private Int2DArray Array;

  private Position Origin;
  private Position Dim;

  Int2DSubArray (Int2DArray Array, Position Origin, Position Dim)
  {
    this.Array = Array;
    this.Origin = Origin;
    this.Dim = Dim;
  }

  public int Get (Position p)
  {
    return Array.Get (Origin.Plus (p));
  }

  public void Set (Position p, int v)
  {
    Array.Set (Origin.Plus (p), v);
  }

  public Position Dimension ()
  {
    return Dim;
  }

  public Position GetOrigin ()
  {
    return Origin;
  }

  public Int2DSubArray Quadrant (int Index)
  {
    return new Int2DSubArray
        ( Array
        , Origin.Plus
          ( new Position ( (Index & 1) == 0 ? 0 : Dim.X () / 2
                         , (Index & 2) == 0 ? 0 : Dim.Y () / 2
                         )
          )
        , new Position (Dim.X () / 2, Dim.Y () / 2)
        );
     
  }

  public static void main (String [] args)
  {
    Quantized2D S = new Quantized2D (new Position (3, 3));
    S.Set (new Position (0, 0), 11);
    S.Set (new Position (1, 0), 12);
    S.Set (new Position (2, 0), 13);
    S.Set (new Position (0, 1), 21);
    S.Set (new Position (1, 1), 22);
    S.Set (new Position (2, 1), 23);
    S.Set (new Position (0, 2), 31);
    S.Set (new Position (1, 2), 32);
    S.Set (new Position (2, 2), 33);
    S.Print ();
    Int2DSubArray DSA = new Int2DSubArray (S, new Position (0, 1), new Position (2, 2));
    DSA.Print ();
  }
}
