class SymbolStatistics
{
  GrowableIntArray SymbolCount[];

  SymbolStatistics ()
  {
    SymbolCount = new GrowableIntArray[100];
    for (int i = 0; i < 100; i ++)
        SymbolCount[i] = new GrowableIntArray ();
  }

  void AddSymbol (int Symbol, int Context)
  {
    SymbolCount[Context].Set (Symbol, SymbolCount[Context].Get (Symbol) + 1);
  }

  int GetSymbolCount (int Symbol, int Context)
  {
    return SymbolCount[Context].Get (Symbol);
  }

  int GetSymbolCount (int Context)
  {
    GrowableIntArray A = SymbolCount[Context];
    int c = 0;
    for (int i = 0; i < A.Length (); i ++)
        c += A.Get (i);
    return c;
  }

  int GetSymbolCount ()
  {
    int c = 0;
    for (int i = 0; i < 100; i ++)
        c += GetSymbolCount (i);
    return c;
  }

  int GetSymbolRange (int Context)
  {
    return SymbolCount[Context].Length ();
  }

  int GetSymbolRange ()
  {
    int max = 0;
    for (int i = 0; i < 100; i ++)
        if (max < GetSymbolRange (i))
           max = GetSymbolRange (i);
    return max;
  }

  void Print ()
  {
    for (int i = 0; i < 100; i ++)
        if (GetSymbolCount (i) > 0)
        {  System.out.print (i);
           System.out.print (": ");
           SymbolCount[i].Print ();
        }
  }

  public static void main (String[] args)
  {
    SymbolStatistics SS = new SymbolStatistics ();
    SS.AddSymbol (1, 1);
    SS.AddSymbol (1, 1);
    SS.AddSymbol (0, 3);
    SS.AddSymbol (2, 3);
    SS.AddSymbol (5, 3);
    SS.AddSymbol (5, 3);
    System.out.println (SS.GetSymbolCount ());
    System.out.println (SS.GetSymbolCount (1));
    System.out.println (SS.GetSymbolCount (2));
    System.out.println (SS.GetSymbolCount (3));
    SS.Print ();
  }
}
